"use strict";

PH.albumCache=(function(){ //functiuon returning an object
    var picsInAlbum=[];
    var mediaShadow=[];
    var pathStr=null;
    var albumTitle,nrDisplayPictures;
    var cPicAlbumIndex=-1; //current pic index in album (valid: 0-picsInAlbum.length-1)
    var cPicCacheIndex=-1; //current pic index in cache array (valid: 0-imgCache.length-1)
    var loadingImg=null; //the currently loading img object
    var widthOnEntry=-1;
    var showingImg=-1; //in the beginning there is no img showing
    var showInfo=true;
    var spinner=null;
    var map=null,photoMarker=null;
    var picWatchStartTime=null,thmbWatchStartTime=null;
    var direction=0; //1 if going forward, -1 if going backwords
    var zoomInElm=null,zoomOutElm=null,zoombox=null;
    var infobox=null; //=elm('img-info'); //caching this
    var imgDiv=null;

    var KCacheRadius=2;

    var statusFlags={
        FlagThumbnailLoading:1,
        FlagThumbnailLoaded:2,
        FlagMediaLoading:4,
        FlagMediaLoaded:8,
        FlagMediaPrefetchSent:16
    };
    var spinnerOpts={
        lines: 11, // The number of lines to draw
        length: 5, // The length of each line
        width: 3, // The line thickness
        radius: 7, // The radius of the inner circle
        corners: 1, // Corner roundness (0..1)
        rotate: 0, // The rotation offset
        direction: 1, // 1: clockwise, -1: counterclockwise
        color: '#FFFFFF', // #rgb or #rrggbb or array of colors
        speed: 1, // Rounds per second
        trail: 60, // Afterglow percentage
        shadow: false, // Whether to render a shadow
        hwaccel: false, // Whether to use hardware acceleration
        className: 'spinner', // The CSS class to assign to the spinner
        zIndex: 2e9, // The z-index (defaults to 2000000000)
        top: '50%', // Top position relative to parent
        left: '50%' // Left position relative to parent
    };
    var _newElement=function(i){
        var p;
        console.assert(typeof(picsInAlbum[i].t)==='undefined');
        //create the div container
        p=document.createElement('div');
        p.id='media'+i;
        p.className='mediadiv';
        p.style.display='none';
        
        //create the elements inside the container
        if(!(picsInAlbum[i].fl&PH.server.albumFlags.FlagIsVideo))
            p.innerHTML='<img class="fsimg" src=""><img class="fsimg" src="">'; //image
        //a video would be created like this:
        //p.innerHTML='<video id="videoelm" controls preload="metadata" class="fsvideo"><source type="video/mp4"/></video>';
        return p;
    };
    
    var _newShadowElement=function(i){
        var r={
            photostovisI:i,
            photostovisStatus:0,
            photostovisRot:'',
            photostovisZoom:0
        };
        return r;
    };
    
    var _removeElement=function(i){
        //remove the DOM element(s). This function is important, otherwise memory leaks will kill the browser
        var p=imgDiv.children[i],r;
        var s=mediaShadow.splice(i,1)[0];//remove the mediaShadow element
        var isVideo=picsInAlbum[s.photostovisI].fl&PH.server.albumFlags.FlagIsVideo?true:false;
        console.log("_removeElement++: nr children of elm2remove="+p.children.length+". Is video="+isVideo);

        //is there anything to remove?
        if(p.children.length>0){
            //is this a video or image?
            if(isVideo){
                console.assert(p.children.length===1);
                r=p.children[0];
                r.removeEventListener('loadedmetadata',_metadataLoaded);
                r.pause();
                r.src="";
                r.load();
                p.removeChild(r);
            } else {
                //this is an image
                console.assert(p.children.length<=2);
                while(p.lastChild){
                    r=p.lastChild;
                    r.removeEventListener('load',_imageLoaded);
                    if(r===loadingImg)
                        loadingImg=null;
                    r.style.cssText='';
                    r.style.display='';
                    r.style.transition='';
                    r.style.top=null;
                    r.style.left=null;
                    //r.src='';
                    p.removeChild(r);
                }
            }
            console.assert(p.children.length===0);
            p.innerHTML='';
        }//if(p.children.length>0)
        imgDiv.removeChild(p);

        console.assert(imgDiv.children.length===mediaShadow.length);
        console.log("_removeElement--");
    };
    
    var _getNextIndex=function(i){
        //console.log("_getNextIndex")
        var n=i+1;
        while(n<picsInAlbum.length){
            if(typeof(picsInAlbum[n].t)==='undefined')return n;//this is an image
            else n++;//this is an album that we skip
        }
        return -1; //not found
    };
    var _getPrevIndex=function(i){
        var p=i-1;
        while(p>=0){
            if(typeof(picsInAlbum[p].t)==='undefined')return p;//this is an image
            else p--;//this is an album that we skip
        }
        return -1; //not found
    };
    var _sizeImg=function(i,childIndex){
        console.assert(i>=0 && i<imgDiv.children.length);
        var imgWidth,imgHeight; //we cannot trust r.width and r.height because they are not rotated
        var rot,dw,dh,hr,vr;
        var cssText='';
        var s=mediaShadow[i];
        var p=imgDiv.children[i];
        console.assert(p.children.length>childIndex);
        var imgNatWidth,imgNatHeight,imgNatTmp;
        var albumElm=picsInAlbum[s.photostovisI];
        var r=p.children[childIndex];

        console.log("");
        console.groupCollapsed("sizeImg with photostovisI="+s.photostovisI);
        console.assert(r.height>0 && r.width>0,"r.height="+r.height+", r.width="+r.width);
        rot=albumElm.rot;
        console.assert(typeof(albumElm.w)==='number' && typeof(albumElm.h)==='number');
        

        if(rot===90 || rot===270){
            //switch width and height
            console.log("Switching width and height ...");
            imgWidth=albumElm.h;
            imgHeight=albumElm.w;
        } else {
            imgWidth=albumElm.w;
            imgHeight=albumElm.h;
        }
        //moved here from below, see comments
        if(s.photostovisRot.length)
            cssText+=PH.platform.transformPrefix+'transform:'+s.photostovisRot+'; ';
        else rot=0;

        imgNatWidth=r.naturalWidth>0?r.naturalWidth:r.width;
        imgNatHeight=r.naturalHeight>0?r.naturalHeight:r.height;
        if((imgWidth>imgHeight && imgNatWidth<imgNatHeight) || (imgWidth<imgHeight && imgNatWidth>imgNatHeight)){
            //switch
            imgNatTmp=imgNatWidth;
            imgNatWidth=imgNatHeight;
            imgNatHeight=imgNatTmp;
        }

        //it is possible that the if(...)rot=0 line must be here below for ios6 and above for ios7. To be checked with an ios6 at some point
        //if(s.photostovisRot==='')rot=0;

        dw=document.documentElement.clientWidth;
        dh=document.documentElement.clientHeight;
        hr=dw/imgWidth;
        vr=dh/imgHeight;
        console.log("Image Width="+imgWidth+" Image Height="+imgHeight);
        console.log("Document Width="+document.documentElement.clientWidth+" Document Height="+document.documentElement.clientHeight);
        console.log("Horizontal ratio="+hr+" Vertical ratio="+vr);
        
        //console.log("JSON width="+albumElm.w+", JSON height="+albumElm.h);
        
        if(hr<vr){
            if(rot===90 || rot===270){
                //switch width and height
                s.photostovisWidth=imgHeight*hr;
                s.photostovisLeft=(dw-s.photostovisWidth)/2;
                s.photostovisHeight=dw;
                s.photostovisTop=(dh-s.photostovisWidth)/2;
                s.photostovisTop0=(s.photostovisWidth-s.photostovisHeight)/2;
                s.photostovisLeft0=(s.photostovisHeight-s.photostovisWidth)/2;
                //zoom dimensions
                s.photostovisZ1Width=dh;
                s.photostovisZ1Height=vr*imgWidth;
                s.photostovisZ1Top=(s.photostovisZ1Width-s.photostovisZ1Height)/2;;
                s.photostovisZ1Left=(s.photostovisZ1Height-s.photostovisZ1Width)/2;
                s.photostovisZ1ScrollLeft=(s.photostovisZ1Height-dw)/2;
            } else {
                s.photostovisWidth=dw;
                s.photostovisLeft=(dw-s.photostovisWidth)/2;
                s.photostovisHeight=imgHeight*hr;
                s.photostovisTop=(dh-s.photostovisHeight)/2;
                s.photostovisTop0=0;
                s.photostovisLeft0=0;
                //zoom dimensions
                s.photostovisZ1Height=dh;
                s.photostovisZ1Width=vr*imgWidth;
                s.photostovisZ1Top=0;
                s.photostovisZ1Left=0;
                s.photostovisZ1ScrollLeft=(s.photostovisZ1Width-dw)/2;
            }
            s.photostovisZ1ScrollTop=0;

            console.log("Full width. Scaled height="+s.photostovisHeight+" Distance to top="+s.photostovisTop);
        } else {
            if(rot===90 || rot===270){
                //switch width and height
                s.photostovisWidth=dh;
                s.photostovisLeft=(dw-s.photostovisWidth)/2;
                s.photostovisHeight=imgWidth*vr;
                s.photostovisTop0=s.photostovisTop=(s.photostovisWidth-s.photostovisHeight)/2;
                //if the black lateral margins are wider than 360+5 pixels, do NOT move the picture to the left
                if((dw-imgWidth*vr)/2>=365)
                    s.photostovisLeft0=s.photostovisLeft;
                else
                    s.photostovisLeft0=(s.photostovisHeight-s.photostovisWidth)/2;
                //zoom dimensions
                s.photostovisZ1Height=dw;
                s.photostovisZ1Width=hr*imgHeight;
                s.photostovisZ1Top=(s.photostovisZ1Width-s.photostovisZ1Height)/2;
                s.photostovisZ1Left=(s.photostovisZ1Height-s.photostovisZ1Width)/2;
                s.photostovisZ1ScrollTop=(s.photostovisZ1Width-dh)/2;
            } else {
                s.photostovisWidth=imgWidth*vr;
                s.photostovisLeft=(dw-s.photostovisWidth)/2;
                s.photostovisHeight=dh;
                s.photostovisTop0=s.photostovisTop=0;
                //if the black lateral margins are wider than 360+5 pixels, do NOT move the picture to the left
                if(s.photostovisLeft>=365)
                    s.photostovisLeft0=s.photostovisLeft;
                else
                    s.photostovisLeft0=0;

                //zoom1 dimensions
                s.photostovisZ1Width=dw;
                s.photostovisZ1Height=hr*imgHeight;
                s.photostovisZ1Top=0;
                s.photostovisZ1Left=0;
                s.photostovisZ1ScrollTop=(s.photostovisZ1Height-dh)/2;
            }
            s.photostovisZ1ScrollLeft=0;

            console.log("Full height. Scaled width="+s.photostovisWidth+" Distance to left="+s.photostovisLeft+" Distance to top="+s.photostovisTop);
        }

        //zoom2 dimensions
        if(rot===90 || rot===270){
            s.photostovisZ2Height=imgNatWidth/PH.platform.pixelRatio;
            s.photostovisZ2Width=imgNatHeight/PH.platform.pixelRatio;
            if(dw-s.photostovisZ2Height>0){
                s.photostovisZ2Left=(dw-s.photostovisZ2Width)/2;
                s.photostovisZ2ScrollLeft=0;
            } else {
                s.photostovisZ2Left=(s.photostovisZ2Height-s.photostovisZ2Width)/2;
                s.photostovisZ2ScrollLeft=(s.photostovisZ2Height-dw)/2;
            }
            if(dh-s.photostovisZ2Width>0){
                s.photostovisZ2Top=(dh-s.photostovisZ2Height)/2;
                s.photostovisZ2ScrollTop=0;
            } else {
                s.photostovisZ2Top=(s.photostovisZ2Width-s.photostovisZ2Height)/2;
                s.photostovisZ2ScrollTop=(s.photostovisZ2Width-dh)/2;
            }
        } else {
            s.photostovisZ2Width=imgNatWidth/PH.platform.pixelRatio;
            s.photostovisZ2Height=imgNatHeight/PH.platform.pixelRatio;
            if(dw-s.photostovisZ2Width>0){
                s.photostovisZ2Left=(dw-s.photostovisZ2Width)/2;
                s.photostovisZ2ScrollLeft=0;
            } else {
                s.photostovisZ2Left=0;
                s.photostovisZ2ScrollLeft=(s.photostovisZ2Width-dw)/2;
            }
            if(dh-s.photostovisZ2Height>0){
                s.photostovisZ2Top=(dh-s.photostovisZ2Height)/2;
                s.photostovisZ2ScrollTop=0;
            } else {
                s.photostovisZ2Top=0;
                s.photostovisZ2ScrollTop=(s.photostovisZ2Height-dh)/2;
            }
        }

        //new stuff: create the cssText
        switch(s.photostovisZoom){
        case 0:
            cssText+='width:'+s.photostovisWidth+'px; height:'+s.photostovisHeight+'px; top:';
            if(showInfo)
                cssText+=s.photostovisTop0+'px; left:'+s.photostovisLeft0+'px;';
            else
                cssText+=s.photostovisTop+'px; left:'+s.photostovisLeft+'px;';
            break;
        case 1:
            cssText+='width:'+s.photostovisZ1Width+'px; height:'+s.photostovisZ1Height+'px; top:'+s.photostovisZ1Top+'px; left:'+s.photostovisZ1Left+'px;';
            break;
        case 2:
            cssText+='width:'+s.photostovisZ2Width+'px; height:'+s.photostovisZ2Height+'px; top:'+s.photostovisZ2Top+'px; left:'+s.photostovisZ2Left+'px;';
            break;
        }//switch
        r.style.cssText=cssText;
        console.groupEnd();
    };
    var _getInfoText=function(c,img){
        var camera,mp,mb;
        var sc_num,sc_denom;
        var txt;

        if(typeof(c.m)==='number' && c.m!==0xFFFF){
            camera=PH.server.metadata.m[c.m];
            console.assert(typeof(camera.c)==='string' && camera.c.length>=0);
        } else camera=null;
        console.log("Picture data:");
        console.log(c);
        console.log("CAMERA:");
        console.log(camera);

        //album title row
        txt='<h4>'+albumTitle+' ('+(c.displayNr)+'/'+nrDisplayPictures+')</h4>';
        //title row
        txt+='<h1>'+c.fn+'</h1>';
        //date row
        if(c.c!==0x7FFFFFFF)
            txt+='<h2>'+PH.getFormattedDateTime(c.c)+'</h2>';

        //Original image data
        if(c.sz<1048576)mb=(c.sz/1024).toFixed(0)+' KB';
        else mb=(c.sz/1048576).toFixed(1)+' MB';
        console.assert(c.w>0 && c.h>0,"c.w="+c.w+", c.h="+c.h);
        mp=c.w*c.h/1000000;
        mp=mp.toFixed(1)+' Mpix';

        txt+='<table><tr><td>Original:</td><td class="right">'+c.w+'</td><td>x</td><td>'+c.h+'</td><td class="right">('+mp+
                '</td><td>/</td><td>'+mb+')</td></tr>';

        //transfered image data
        console.assert(img.width>0 && img.height>0);
        if(typeof(img.naturalWidth)!=='undefined'){
            if(img.naturalWidth===c.w && img.naturalHeight===c.h){
                txt+='<tr><td>On screen:</td><td colspan="6" class="originalimg">original image</td></tr>';
                sc_num=0;
            } else {
                //mp=(c.w/img.naturalWidth)*(c.h/img.naturalHeight);
                sc_num=Math.round(img.naturalWidth*8/c.w);
                console.assert(sc_num>0 && sc_num<8);
            }
        } else {
            if(img.width===c.w && img.height===c.h){
                txt+='<tr><td>On screen:</td><td colspan="6" class="originalimg">original image</td></tr>';
                sc_num=0;
            } else {
                //mp=(c.w/img.width)*(c.h/img.height);
                sc_num=Math.round(img.width*8/c.w);
                console.assert(sc_num>0 && sc_num<8);
            }
        }
        if(sc_num>0){
            if(sc_num===4){
                sc_num=1;sc_denom=2;
            } else if(sc_num===2 || sc_num===6){
                sc_num/=2;sc_denom=4;
            } else sc_denom=8;
            mp=sc_num+'/'+sc_denom;
            txt+='<tr><td>On screen:</td><td class="right">'+img.naturalWidth+'</td><td>x</td><td>'+img.naturalHeight+
                '</td><td colspan="3" class="center">('+mp+'x'+mp+' from original)</td></tr>';
        }


        txt+='</table>';
        //Camera & nr pictures
        if(camera)
            txt+='<h2>Camera: '+camera.c+'</h2><h3>('+camera.p+' pictures taken with this camera)</h3>';

        txt+='<table>';
        //Focal length
        if(c.fln)
            txt+='<tr><td class="nowrap">Focal length:</td><td>'+c.fln.toFixed(2)+'mm</td></tr>';
        //Focal length in 35mm
        if(c.fl35)
            txt+='<tr><td class="nowrap">35mm equivalent:</td><td>'+c.fl35+'mm</td></tr>';
        //Exposure
        if(c.et)
            txt+='<tr><td class="nowrap">Exposure time:</td><td>'+c.et.toPrecision()+'s</td></tr>';
        //Exposure program
        if(c.ep)
            txt+='<tr><td class="nowrap">Exposure program:</td><td>'+PH.getExposureProgram(c.ep)+'</td></tr>';
        //F number
        if(c.fnr)
            txt+='<tr><td class="nowrap">F Number:</td><td>f/'+c.fnr.toPrecision()+'</td></tr>';
        //ISO
        if(c.iso)
            txt+='<tr><td class="nowrap">ISO:</td><td>'+c.iso+'</td></tr>';
        //Zoom
        if(c.fl35>0)
            txt+='<tr><td class="nowrap">Zoom (35mm equiv):</td><td>'+(c.fl35/50).toFixed(1)+'</td></tr>';
        else if(c.fln>0 && camera && camera.mfl>0 && camera.p>=100) {
            //we only do this for more than 100 pictures, to increase the probability that at least one of these
            //has the minimum focus length of the camera
            txt+='<tr><td class="nowrap">Zoom (approx.):</td><td>'+(c.fln/camera.mfl).toFixed(1)+'</td></tr>';
        }
        txt+='</table>';
        return txt;
    }

    var _imageLoaded=function(){
        var p=this.parentNode,s,r;
        var i,index=-1;
        var picLoadTime;
        //find our loaded media element among imgDiv children
        for(i=0;i<imgDiv.children.length;i++)
            if(imgDiv.children[i]===p){
                //we found it!
                index=i;
                break;
            }
        if(index<0){
            console.warn("Stray image loaded. Ignoring.");
            return;
        }
        s=mediaShadow[index];

        console.log("Img loaded: "+s.photostovisI+" src="+this.src);

        //rotate the picture if needed. Rotating yelds correct width and height
        if(PH.platform.name==='ios'){
            //on ios the browser will rotate the picture by itself, based on the metadata, so we should NOT rotate it
            s.photostovisRot='';
            if(picsInAlbum[s.photostovisI].rot)
                console.log("This picture would have been rotated, but we are on iOS.");
        } else if(picsInAlbum[s.photostovisI].rot){
            s.photostovisRot='rotate('+picsInAlbum[s.photostovisI].rot+'deg)';
            console.log("Rotating loaded picture: "+s.photostovisRot);
        }
        //mark image as loaded, resize it
        if(s.photostovisStatus&statusFlags.FlagThumbnailLoading){
            s.photostovisStatus+=statusFlags.FlagThumbnailLoaded-statusFlags.FlagThumbnailLoading;
            _sizeImg(index,0);
        } else {
            console.assert(loadingImg.src===this.src);
            console.assert(typeof(s.photostovisLoadStartTime)==='number',s.photostovisLoadStartTime);
            picLoadTime=Date.now()-s.photostovisLoadStartTime;
            console.log("Picture ("+s.photostovisID+") loaded in "+picLoadTime+"ms. startTime="+s.photostovisLoadStartTime);
            PH.sendWebsocketMessage("loadID="+s.photostovisID+" loadTime="+picLoadTime);
            delete s.photostovisLoadStartTime;
            loadingImg=null;
            console.assert(s.photostovisStatus&statusFlags.FlagMediaLoading);
            s.photostovisStatus+=statusFlags.FlagMediaLoaded-statusFlags.FlagMediaLoading;
            _sizeImg(index,1);
        }

        if(s.photostovisPathStr===pathStr){
            if(s.photostovisI===cPicAlbumIndex){
                //show picture
                console.log("Current picture has been loaded, showing it!");
                PH.albumCache.showImg(index,PH.albumCache.loadNextMedia);
            } else //load next picture
                setTimeout(PH.albumCache.loadNextMedia,0);
        }
        delete s.photostovisPathStr;
        //if the image was loaded, delete the thumbnail
        if(s.photostovisStatus&statusFlags.FlagMediaLoaded){
            console.assert(p.children.length===2);
            r=p.children[0];
            r.style.cssText='';
            r.style.display='';
            r.style.transition='';
            r.style.top=null;
            r.style.left=null;
            p.removeChild(r);
        }

        //image metadata
        s.photostovisImgText=_getInfoText(picsInAlbum[s.photostovisI],this);
    };
    
    var _metadataLoaded=function(){
        var p=this.parentNode,s;
        var i,index=-1;
        //find our loaded media element among imgDiv children
        for(i=0;i<imgDiv.children.length;i++)
            if(imgDiv.children[i]===p){
                //we found it!
                index=i;
                break;
            }
        if(index<0){
            console.warn("Stray video metadata loaded. Ignoring.");
            return;
        }
        s=mediaShadow[index];
        console.log("Video Metadata loaded: "+s.photostovisI+". Video dimensions: "+this.videoWidth+"x"+this.videoHeight);
        console.log("Seekable: "+this.seekable+", readyState: "+this.readyState);
        console.log(s);
        //mark video as loaded
        console.assert(s.photostovisStatus&statusFlags.FlagMediaLoading);
        s.photostovisStatus+=statusFlags.FlagMediaLoaded-statusFlags.FlagMediaLoading;
        //size the video
        if(this.videoWidth/this.videoHeight>PH.platform.screenWidth/PH.platform.screenHeight){
            //the video is wider than the screen.
            this.style.width='100%';
            this.style.height='auto';
        } else {
            //the screen is wider than the video.
            this.style.height='100%';
            this.style.width='auto';
        }
        //show or load next (or both)
        if(s.photostovisPathStr===pathStr){
            if(s.photostovisI===cPicAlbumIndex){
                //show video
                console.log("Current video has been loaded, showing it!");
                PH.albumCache.showVideo(index,PH.albumCache.loadNextMedia);
            } else //load next picture
                setTimeout(PH.albumCache.loadNextMedia,0);
        }
        delete s.photostovisPathStr;
        //mark the shadow as having a "stopable" child
        s.photostovisStopable=0;
    };
    
    var _showSpinner=function(){
        if(spinner)spinner.stop();
        spinner=null;
        spinner=new Spinner(spinnerOpts).spin(elm('fsimg-spinner-box'));
    };
    var _hideSpinner=function(){
        if(spinner)spinner.stop();
        spinner=null;
    };
    var _hideShowing=function(){
        if(showingImg<0)return;
        
        var rOld=imgDiv.children[showingImg];
        var sOld=mediaShadow[showingImg];
        rOld.style.display='none';
        if(typeof(sOld.photostovisStopable)==='number' && rOld.children[sOld.photostovisStopable])
            rOld.children[sOld.photostovisStopable].pause();
        showingImg=-1;
    };

    return {
        setShowInfo:function(storedShowInfo){
            showInfo=storedShowInfo;
        },
        getShowInfo:function(){
            return showInfo;
        },
        clear:function(total){
            //clear imgDiv & media Shadow before clearing anything else
            if(imgDiv){
                while(imgDiv.children.length)
                    _removeElement(imgDiv.children.length-1);
                console.assert(loadingImg===null); //because it was made null when the load event was removed, in _removeElement
                imgDiv.innerHTML='';
            }
            mediaShadow=[];
            if(total){
                picsInAlbum=null;
                pathStr=null;
                albumTitle=null;
                nrDisplayPictures=0;
            }
            cPicAlbumIndex=-1; //current pic index in album (valid: 0-picsInAlbum.length-1)
            cPicCacheIndex=-1; //current pic index in cache array (valid: 0-imgCache.length-1)


            showingImg=-1; //in the beginning there is no img showing
            direction=0;
        },
        init:function(picsAlbm,pathString,tt,nrdsp){
            this.clear(true);
            console.log("albumCache::init");
            picsInAlbum=picsAlbm;
            pathStr=pathString;
            albumTitle=tt;
            nrDisplayPictures=nrdsp;
            //console.log(picsInAlbum);
            console.assert(typeof(picsInAlbum)==='object');
            console.assert(Array.isArray(picsInAlbum));
            console.assert(typeof(pathStr)==='string' && pathStr.search('/t/')!==-1);
            //reset timings
            picWatchStartTime=thmbWatchStartTime=null;
            //elm shortcuts
            if(!imgDiv)imgDiv=elm('imgdiv');
            if(!infobox)infobox=elm('img-info');
            if(!zoomInElm)zoomInElm=elm('zoom-in');
            if(!zoomOutElm)zoomOutElm=elm('zoom-out');
            if(!zoombox)zoombox=elm('zoom');
        },
        resize:function(){
            if(!imgDiv)return;
            console.log("resize++");
            var s;
            var j;
            console.assert(imgDiv.children.length===mediaShadow.length);
            for(j=0;j<mediaShadow.length;j++){
                s=mediaShadow[j];
                s.photostovisHeight=-1;
                s.photostovisWidth=-1;
                s.photostovisZ1Height=-1;
                s.photostovisZ1Width=-1;
                s.photostovisZ2Height=-1;
                s.photostovisZ2Width=-1;
            }
            if(showingImg>=0 && cPicAlbumIndex>=0)
                if(!(picsInAlbum[cPicAlbumIndex].fl&PH.server.albumFlags.FlagIsVideo))
                    this.showImg(showingImg,null);
            if(spinner){
                spinner.stop();
                spinner=null;
                spinner=new Spinner(spinnerOpts).spin(elm('fsimg-spinner-box'));
            }
            console.log("resize--");
        },
        loadNextMedia:function(){
            var i=0,index=-1;
            var s,media2load,shadow2load;
            var img2load;
            var albumIndexNext,albumIndexPrev;
            var query;
            var doPrefetching=false;
            
            console.groupCollapsed("loadNextMedia: current="+cPicAlbumIndex);
            console.assert(cPicAlbumIndex<picsInAlbum.length,"Current pic outside range: "+cPicAlbumIndex);
            console.assert(cPicCacheIndex>=0 && cPicCacheIndex<KCacheRadius+1+KCacheRadius,"cPicCacheIndex outside range");
            if(cPicAlbumIndex<0){
                console.log("returning (the user has exited the \"show pictures\" mode");
                console.groupEnd();
                return;
            } //the user has exited the "show pictures" mode

            s=mediaShadow[cPicCacheIndex];
            if(s.photostovisStatus&statusFlags.FlagMediaLoading || s.photostovisStatus&statusFlags.FlagThumbnailLoading){
                //current thumb already loading, we will continue when this is ready
                console.log("loadNextMedia: current thumb or media already loading, will continue with cache loading when it is loaded");
                if(picsInAlbum[cPicAlbumIndex].fl&PH.server.albumFlags.FlagIsVideo){
                    //we show the video even if it is not fully loaded
                    PH.albumCache.showVideo(cPicCacheIndex);
                    console.log("Showing current video");
                }
                console.groupEnd();
                return;
            }
            
            if(s.photostovisStatus&statusFlags.FlagThumbnailLoaded || !(picsInAlbum[cPicAlbumIndex].fl&PH.server.albumFlags.FlagHasThumbnail)){
                //current thumb loaded (or not available), check the current image

                //BUT FIRST: do we have an already loading image? If yes, we should wait until it loads (because we cannot cancel it)
                if(loadingImg){
                    //yes, we have a loading image
                    console.log("!!! We already have a loading image! Wait until it loads.");
                    console.groupEnd();
                    return;
                }

                if(s.photostovisStatus&statusFlags.FlagMediaLoaded){
                    //current image already loaded, we need a new image to load
                    //check first if all thumbnails are loaded
                    albumIndexNext=albumIndexPrev=cPicAlbumIndex;
                    for(i=1;i<KCacheRadius+1;i++){
                        index=cPicCacheIndex+i;
                        albumIndexNext=_getNextIndex(albumIndexNext);
                        if(index<imgDiv.children.length && albumIndexNext!==-1 && 
                                picsInAlbum[albumIndexNext].fl&PH.server.albumFlags.FlagHasThumbnail){
                            media2load=imgDiv.children[index];
                            shadow2load=mediaShadow[index];
                            if(!(shadow2load.photostovisStatus&statusFlags.FlagThumbnailLoaded))break;
                        }

                        index=cPicCacheIndex-i;
                        albumIndexPrev=_getPrevIndex(albumIndexPrev);
                        if(index>=0 && albumIndexPrev!==-1 && 
                                picsInAlbum[albumIndexPrev].fl&PH.server.albumFlags.FlagHasThumbnail){
                            media2load=imgDiv.children[index];
                            shadow2load=mediaShadow[index];
                            if(!(shadow2load.photostovisStatus&statusFlags.FlagThumbnailLoaded))break;
                        }
                    }//for
                    if(i<KCacheRadius+1){
                        console.log("Loading a thumb (index="+index+", current="+cPicCacheIndex+")");
                        shadow2load.photostovisStatus|=statusFlags.FlagThumbnailLoading;
                    } else {
                        //try with an image
                        albumIndexNext=albumIndexPrev=cPicAlbumIndex;
                        for(i=1;i<KCacheRadius+1;i++){
                            //following if prevents videos to be loaded, if they are more than one step after or before the current element
                            albumIndexNext=_getNextIndex(albumIndexNext);
                            albumIndexPrev=_getPrevIndex(albumIndexPrev);
                            if(i===1 || 
                                !(albumIndexNext!==-1 && picsInAlbum[albumIndexNext].fl&PH.server.albumFlags.FlagIsVideo)
                                || !(albumIndexPrev!==-1 && picsInAlbum[albumIndexPrev].fl&PH.server.albumFlags.FlagIsVideo)){
                                index=cPicCacheIndex+i;
                                if(index<imgDiv.children.length){
                                    media2load=imgDiv.children[index];
                                    shadow2load=mediaShadow[index];
                                    if(!(shadow2load.photostovisStatus&statusFlags.FlagMediaLoaded))break;
                                }

                                index=cPicCacheIndex-i;
                                if(index>=0){
                                    media2load=imgDiv.children[index];
                                    shadow2load=mediaShadow[index];
                                    if(!(shadow2load.photostovisStatus&statusFlags.FlagMediaLoaded))break;
                                }
                            }// if (after for)
                        }//for
                        if(i<KCacheRadius+1){
                            console.log("Loading an image/video (not a thumbnail)");
                            shadow2load.photostovisStatus|=statusFlags.FlagMediaLoading;
                        } else {
                            //nothing to load
                            console.log("loadNextMedia: ALL IMAGES IN CACHE LOADED!");
                            //based on our direction prefetch an image
                            if(direction===1){
                                //going forward.
                                albumIndexNext=_getNextIndex(albumIndexNext);
                                if(albumIndexNext!==-1 && !(picsInAlbum[albumIndexNext].fl&PH.server.albumFlags.FlagIsVideo)){
                                    console.log("PREFETCHING image ID="+picsInAlbum[albumIndexNext].id+", priority="+(KCacheRadius+1));
                                    PH.sendWebsocketMessage("prefetchID="+picsInAlbum[albumIndexNext].id+" priority="+(KCacheRadius+1));
                                }
                            } else if(direction===-1){
                                //going backward.
                                albumIndexPrev=_getPrevIndex(albumIndexPrev);
                                if(albumIndexPrev!==-1 && !(picsInAlbum[albumIndexPrev].fl&PH.server.albumFlags.FlagIsVideo)){
                                    console.log("PREFETCHING image ID="+picsInAlbum[albumIndexPrev].id+", priority="+(KCacheRadius+1));
                                    PH.sendWebsocketMessage("prefetchID="+picsInAlbum[albumIndexPrev].id+" priority="+(KCacheRadius+1));
                                }
                            } else console.assert(direction===0);

                            console.groupEnd();
                            return;
                        }
                    }
                } else {
                    console.log("Loading the current media");
                    index=cPicCacheIndex;
                    media2load=imgDiv.children[index];
                    shadow2load=mediaShadow[index];
                    shadow2load.photostovisStatus|=statusFlags.FlagMediaLoading;
                }
            } else {
                console.log("Loading the current thumbnail");
                index=cPicCacheIndex;
                media2load=imgDiv.children[index];
                shadow2load=mediaShadow[index];
                shadow2load.photostovisStatus|=statusFlags.FlagThumbnailLoading;
            }

            //load the current media
            shadow2load.photostovisPathStr=pathStr; //this is used to check if we have the same album
            shadow2load.photostovisID=picsInAlbum[shadow2load.photostovisI].id;
            console.log("loadNextMedia: loading thumb/media with id="+shadow2load.photostovisID+", i="+shadow2load.photostovisI+" and index="+index);
            if(picsInAlbum[shadow2load.photostovisI].fl&PH.server.albumFlags.FlagIsVideo){
                //loading the video
                console.log("Loading video: ");
                console.log(shadow2load);
                console.assert(shadow2load.photostovisStatus&statusFlags.FlagMediaLoading);

                media2load.innerHTML='<video controls class="fsvideo"><source src="'+
                        pathStr.replace('t','v')+shadow2load.photostovisID+(PH.server.key?'?key='+PH.server.key:'')+'"></video>';
                img2load=media2load.children[0];
                console.log("Video media state: "+img2load.readyState);
                //if(img2load.readyState)
                img2load.addEventListener('loadedmetadata',_metadataLoaded);
                img2load.preload='metadata';
                console.log("Metadata will be loaded for video with photostovisI: "+shadow2load.photostovisI);
            } else {
                //loading an image
                if(shadow2load.photostovisStatus&statusFlags.FlagMediaLoading)img2load=media2load.children[1];
                else if(shadow2load.photostovisStatus&statusFlags.FlagThumbnailLoading)img2load=media2load.children[0];
                else console.assert(0);
                
                img2load.addEventListener('load',_imageLoaded);
                 
                if(shadow2load.photostovisStatus&statusFlags.FlagMediaLoading){
                    img2load.src=pathStr.replace('t','i')+shadow2load.photostovisID+'?w='+PH.platform.screenWidth+'&h='+PH.platform.screenHeight+
                            (PH.server.key?'&key='+PH.server.key:'');
                    console.assert(typeof(shadow2load.photostovisLoadStartTime)==='undefined');
                    shadow2load.photostovisLoadStartTime=Date.now();
                    console.log("Starting loading picture ("+shadow2load.photostovisID+") at "+shadow2load.photostovisLoadStartTime);
                    loadingImg=img2load;
                    doPrefetching=true; //this will make the prefetch code below to run
                }else {
                    query=PH.platform.pixelRatioTxtThmb;
                    if(PH.server.key)query+='&key='+PH.server.key;
                    if(query.length>0 && query.charAt(0)!=='?')
                        query='?'+query.slice(1);
                    
                    img2load.src=pathStr+shadow2load.photostovisID+query;
                }
            }

            if(doPrefetching){
                //prefetching next image
                albumIndexNext=albumIndexPrev=cPicAlbumIndex;
                shadow2load=null; //not really necessary
                for(i=1;i<KCacheRadius+1;i++){
                    //following if prevents videos to be loaded
                    albumIndexNext=_getNextIndex(albumIndexNext);
                    albumIndexPrev=_getPrevIndex(albumIndexPrev);
                    if(!(albumIndexNext!==-1 && picsInAlbum[albumIndexNext].fl&PH.server.albumFlags.FlagIsVideo) ||
                       !(albumIndexPrev!==-1 && picsInAlbum[albumIndexPrev].fl&PH.server.albumFlags.FlagIsVideo)){
                        index=cPicCacheIndex+i;
                        if(index<imgDiv.children.length){
                            shadow2load=mediaShadow[index];
                            if(!(shadow2load.photostovisStatus&statusFlags.FlagMediaLoaded) &&
                               !(shadow2load.photostovisStatus&statusFlags.FlagMediaLoading) &&
                               !(shadow2load.photostovisStatus&statusFlags.FlagMediaPrefetchSent))break;
                        }

                        index=cPicCacheIndex-i;
                        if(index>=0){
                            shadow2load=mediaShadow[index];
                            if(!(shadow2load.photostovisStatus&statusFlags.FlagMediaLoaded) &&
                               !(shadow2load.photostovisStatus&statusFlags.FlagMediaLoading) &&
                               !(shadow2load.photostovisStatus&statusFlags.FlagMediaPrefetchSent))break;
                        }
                    }// if (after for)
                }//for
                if(i<KCacheRadius+1){
                    shadow2load.photostovisStatus|=statusFlags.FlagMediaPrefetchSent;
                    if(typeof(shadow2load.photostovisID)!=='string')
                        shadow2load.photostovisID=picsInAlbum[shadow2load.photostovisI].id;
                    console.log("PREFETCHING image ID="+shadow2load.photostovisID+", priority="+i);
                    PH.sendWebsocketMessage("prefetchID="+shadow2load.photostovisID+" priority="+i);
                } else //nothing to prefetch
                    console.log("No image needs prefetching.");
            }//if(!prefetchPriority)

            console.groupEnd();
        },//loadNextMedia
        displayMedia:function(i){
            var j,ii;
            var p=null,r=null,s,targetLength;

            console.assert(i>=0 && i<picsInAlbum.length,"i outside range: "+i);
            console.assert(imgDiv.children.length<=KCacheRadius+1+KCacheRadius,"imgDiv.children.length is not less than "+
                           (KCacheRadius+1+KCacheRadius)+" but "+imgDiv.children.length);
            console.assert(typeof(picsInAlbum[i].t)==='undefined',"displayMedia: element is not picture!");
            console.assert(imgDiv.children.length===mediaShadow.length);
            console.log(" ");
            console.log("displayMedia++: current="+i);
            PH.inPictureMode=true;
            
            if(widthOnEntry<0)
                widthOnEntry=document.body.clientWidth;

            //set cPicXXXIndex
            cPicAlbumIndex=i;
            cPicCacheIndex=-1; //we do not know it yet

            //find our element among the divs, if any
            for(j=0;j<mediaShadow.length;j++)
                if(mediaShadow[j].photostovisI===i){
                    cPicCacheIndex=j;
                    break;
                }
            if(cPicCacheIndex>=0){
                //remove too "small" elements from the front of the img array
                while(cPicCacheIndex>KCacheRadius){
                    //remove the media element
                    _removeElement(0);
                    //done with removing
                    if(showingImg>=0)showingImg--;
                    cPicCacheIndex--;
                }
                //remove all elements that are too "big"
                for(j=cPicCacheIndex+KCacheRadius+1;j<imgDiv.children.length;j++){
                    _removeElement(cPicCacheIndex+KCacheRadius+1);
                }
            } else {
                //array should be "empty", set the current element as the first and nullify the rest
                console.assert(imgDiv.children.length===0);
                console.assert(mediaShadow.length===0);
                console.log("adding first element");
                imgDiv.appendChild(_newElement(i));
                mediaShadow.push(_newShadowElement(i));
                cPicCacheIndex=0;
            }
            console.assert(cPicCacheIndex>=0,"cPicCacheIndex is not >=0 but "+cPicCacheIndex);

            //adding elements in front
            while(cPicCacheIndex<KCacheRadius){
                //get the element index
                ii=_getPrevIndex(mediaShadow[0].photostovisI);
                if(ii<0)break; //we do not have a prev element

                imgDiv.insertBefore(_newElement(ii),imgDiv.children[0]);
                mediaShadow.unshift(_newShadowElement(ii));

                console.log("#### displayMedia: added to cache before current: "+ii);
                cPicCacheIndex++;
                if(showingImg>=0)showingImg++;
                console.log("Showing img: "+showingImg);
            }

            //change the elements after the current element
            console.assert(imgDiv.children.length-cPicCacheIndex<=KCacheRadius+1,"imgDiv.children.length="+imgDiv.children.length+", cPicCacheIndex="+cPicCacheIndex);
            targetLength=cPicCacheIndex+KCacheRadius+1; //KCacheRadius more elements after the current element (KCacheRadius+1, 1 is for current element)
            for(j=imgDiv.children.length;j<targetLength;j++){
                ii=_getNextIndex(mediaShadow[j-1].photostovisI);
                if(ii<0)break; //we do not have a next element
                imgDiv.appendChild(_newElement(ii));
                mediaShadow.push(_newShadowElement(ii));
                console.log("#### displayMedia: added to cache after current: "+ii);
            }
            console.assert(imgDiv.children.length<=KCacheRadius+1+KCacheRadius,imgDiv.children.length);
            console.assert(imgDiv.children.length===mediaShadow.length);

            //check if the IDs are in order AND remove video elements for elements that are too far
            for(j=0;j<imgDiv.children.length;j++){
                p=imgDiv.children[j];
                s=mediaShadow[j];
                console.assert(s.photostovisI>=0);
                if(j>0)
                    console.assert(mediaShadow[j-1].photostovisI<s.photostovisI,"not consecutive");
                //is the current element a video elelemt?
                if((picsInAlbum[s.photostovisI].fl&PH.server.albumFlags.FlagIsVideo) && !(j-cPicCacheIndex<=1 && j-cPicCacheIndex>=-1) && p.children.length>0){
                    console.log("Clearing video:");
                    console.log(p);
                    console.log(s);
                    console.assert(p.children.length===1);
                    r=p.children[0];
                    r.removeEventListener('loadedmetadata',_metadataLoaded);
                    r.pause();
                    r.src="";
                    r.load();
                    p.innerHTML='';
                    s.photostovisStatus=0;
                }
                        
            }
            console.log("Current showingImg="+showingImg+", current picture index="+cPicCacheIndex);

            //check first the status of the current element
            if(picsInAlbum[cPicAlbumIndex].fl&PH.server.albumFlags.FlagIsVideo)
                this.showVideo(cPicCacheIndex,this.loadNextMedia);
            else
                this.showImg(cPicCacheIndex,this.loadNextMedia); 

            console.log("displayMedia--");
        },
        showImg:function(i,callback){
            console.assert(i>=0);
            console.assert(i===cPicCacheIndex);
            var r,p,s,c;
            var mapOptions,photoPos;
            var imgChildIndex=0;
            
            p=imgDiv.children[i];
            s=mediaShadow[i];
            //check if we have something to show
            if(!(s.photostovisStatus&statusFlags.FlagThumbnailLoaded || s.photostovisStatus&statusFlags.FlagMediaLoaded)){
                //nothing to show, we should return.
                console.log("showImg: nothing to show, returning.");
                //but first, call the callback, if any
                if(callback)
                    setTimeout(callback,0);
                return;
            }
            console.assert(cPicCacheIndex>=0);
            
            //find out r
            if(s.photostovisStatus&statusFlags.FlagMediaLoaded){
                if(p.children.length===1){
                    //thumbnail was removed
                    r=p.children[0];
                } else {
                    //thumbnail was not removed YET
                    console.assert(p.children.length===2);
                    r=p.children[1];
                    imgChildIndex=1;
                    p.children[0].style.display='none';
                }
            } else {
                r=p.children[0];
            }
            //we need this here because the screen size might have been changed since the picture was loaded, and a resize was triggered
            if(s.photostovisHeight<=0 || s.photostovisWidth<=0){
                console.log("Looks like we need to resize. s: ("+s.photostovisHeight+" "+s.photostovisWidth+")");
                console.log(s);
                _sizeImg(i,imgChildIndex);
                console.log("Resize done: s: ("+s.photostovisHeight+" "+s.photostovisWidth+")");
            }
            console.assert(r);

            console.log("showImg: photostovisI="+s.photostovisI);

            //hide the currently showing set of images, if any
            _hideShowing();

            //set vars
            showingImg=cPicCacheIndex;

            //show/hide things
            if(s.photostovisStatus&statusFlags.FlagMediaLoaded){
                _hideSpinner();
                picWatchStartTime=Date.now();
            } else {
                _showSpinner();
                thmbWatchStartTime=Date.now();
            }

            //show the right picture info
            if(s.photostovisZoom!==2){
                if(showInfo){
                    //update & show information
                    c=picsInAlbum[cPicAlbumIndex];
                    infobox.children[0].style.display='none';
                    if(typeof(s.photostovisImgText)!=='string')
                        s.photostovisImgText=_getInfoText(c,r);
                    infobox.children[1].innerHTML=s.photostovisImgText;
                    //map
                    if(typeof(c.lat)!=='undefined' && typeof(google)!=='undefined'){
                        console.assert(typeof(c.lng)!=='undefined');
                        console.log("We have GPS pos: lat="+(c.lat/1000000)+", lng="+c.lng/1000000);
                        if(!map){
                            mapOptions={
                                center: {lat:c.lat/1000000, lng:c.lng/1000000},
                                zoom: 15
                            };
                            map=new google.maps.Map(infobox.children[2],mapOptions);
                            photoMarker=new google.maps.Marker({map: map});
                        }
                        //display the photomap
                        infobox.children[2].style.display=null;
                        google.maps.event.trigger(map,'resize');
                        //center the map
                        photoPos=new google.maps.LatLng(c.lat/1000000,c.lng/1000000);
                        map.setCenter(photoPos);
                        photoMarker.setPosition(photoPos);
                    } else infobox.children[2].style.display='none';
                    infobox.style.width=null;
                    infobox.style.height=null;
                    if(s.photostovisZoom===0){
                        r.style.top=s.photostovisTop0+"px";
                        r.style.left=s.photostovisLeft0+"px";
                    }
                } else {
                    //show the info icon
                    infobox.children[0].style.display=null;
                    infobox.style.width="34px";
                    infobox.style.height="34px";
                    if(s.photostovisZoom===0){
                        r.style.top=s.photostovisTop+"px";
                        r.style.left=s.photostovisLeft+"px";
                    }
                }

                infobox.style.display=null;
            } else
                infobox.style.display='none';


            //set the right zoom image
            switch(s.photostovisZoom){
            case 0:
                zoomOutElm.style.display='none';
                zoomInElm.style.display='block';
                break;
            case 1:
                if(s.photostovisZ2Width>s.photostovisZ1Width){
                    zoomOutElm.style.display='none';
                    zoomInElm.style.display='block';
                } else {
                    zoomInElm.style.display='none';
                    zoomOutElm.style.display='block';
                }
                break;
            case 2:
                if(s.photostovisWidth>s.photostovisZ2Width){
                    zoomOutElm.style.display='none';
                    zoomInElm.style.display='block';
                } else {
                    zoomInElm.style.display='none';
                    zoomOutElm.style.display='block';
                }
                break;
            }
            zoombox.style.display=null;

            r.style.display=null;//unhide the picture
            p.style.display=null;//unhide the "master" element
            
            console.log("Current image shown. Loading next image.");
            if(callback)
                setTimeout(callback,100);

        },
        showVideo:function(i,callback){
            console.assert(i>=0);
            var p,s;

            p=imgDiv.children[i];
            s=mediaShadow[i];
            
            
            //check if we have something to show
            if(!(s.photostovisStatus&statusFlags.FlagMediaLoaded)){
                //nothing to show yet
                console.log("showVideo: nothing to show, yet.");
                _showSpinner();
            } else _hideSpinner();
            console.assert(cPicCacheIndex>=0);

            console.log("showVideo: photostovisI="+s.photostovisI);

            //hide the currently showing set of images, if any
            _hideShowing();

            //set vars
            showingImg=cPicCacheIndex;

            //hide zoombox
            zoombox.style.display='none';
            //hide infobox
            infobox.style.display='none';

            p.style.display=null;//unhide it

            if(callback)
                setTimeout(callback,0);

        },
        getOut:function(){
            _hideShowing();
            _hideSpinner();

            cPicAlbumIndex=-1;
            PH.path[PH.path.length-1].index=-1;
            PH.inPictureMode=false;
            
            //exit full screeen, then continue
            setTimeout(function(){
                PH.exitFullScreen();
                //hide the picture mode div
                elm('imgdiv').style.display='';
                elm('fullscreendiv').style.display='';
                //do we have the same width on exit as on entry?
                if(widthOnEntry!==document.body.clientWidth){
                    //no, we don't. We need to redisplay the album
                    PH.computeThumbnailStrip();
                    PH.displayAlbum(true); //"true" preserves the position
                } else {
                    //display the album, if needed
                    if(typeof(PH.path[PH.path.length-1].forceDisplay)==='boolean' && PH.path[PH.path.length-1].forceDisplay){
                        delete PH.path[PH.path.length-1].forceDisplay;
                        PH.displayAlbum();
                    } else if(PH.loadingThumbnailsStartTime){
                        //if non-zero it means that thumbnails did not finish loading
                        PH.loadingThumbnails=[];
                        PH.skipInvisible=true;
                        PH.loadingThumbnailsStartTime=Date.now();
                        PH.currentScrollTop=elm('cntnt').scrollTop;
                        PH.loadThumbnails();
                    }
                }
                //remove all elements
                setTimeout(function(){
                    PH.albumCache.clear(false);
                },0);
            },100);
        },
        showNext:function(){
            if(cPicAlbumIndex<0)return;
            var timeNow=Date.now();
            var picWatchTime=-1,thmbWatchTime=-1;
            if(picWatchStartTime)picWatchTime=timeNow-picWatchStartTime;
            if(thmbWatchStartTime){
                if(picWatchStartTime)thmbWatchTime=picWatchStartTime-thmbWatchStartTime;
                else thmbWatchTime=timeNow-thmbWatchStartTime; //the user watched the thumbnail all the time (picture was not loading)
            }
            if(showingImg>=0)
                PH.sendWebsocketMessage("watchedID="+mediaShadow[showingImg].photostovisID+" picWT="+picWatchTime+" thmbWT="+thmbWatchTime);
            picWatchStartTime=thmbWatchStartTime=null;
            direction=1;
            PH.path[PH.path.length-1].index=_getNextIndex(cPicAlbumIndex); //returned result can be -1
            PH.setHash();
        },
        showPrev:function(){
            if(cPicAlbumIndex<0)return;
            var timeNow=Date.now();
            var picWatchTime=-1,thmbWatchTime=-1;
            if(picWatchStartTime)picWatchTime=timeNow-picWatchStartTime;
            if(thmbWatchStartTime){
                if(picWatchStartTime)thmbWatchTime=picWatchStartTime-thmbWatchStartTime;
                else thmbWatchTime=timeNow-thmbWatchStartTime; //the user watched the thumbnail all the time (picture was not loading)
            }
            if(showingImg>=0)
                PH.sendWebsocketMessage("watchedID="+mediaShadow[showingImg].photostovisID+" picWT="+picWatchTime+" thmbWT="+thmbWatchTime);
            picWatchStartTime=thmbWatchStartTime=null;
            direction=-1;
            PH.path[PH.path.length-1].index=_getPrevIndex(cPicAlbumIndex); //returned result can be -1
            PH.setHash();
        },
        getPathStr:function(){
            return pathStr;
        },
        currentIsVideo:function(){
            if(cPicAlbumIndex>=0 && (picsInAlbum[cPicAlbumIndex].fl&PH.server.albumFlags.FlagIsVideo))
                return true;
            return false;
        },
        currentElmZoom:function(){
            if(cPicCacheIndex>=0)
                return mediaShadow[cPicCacheIndex].photostovisZoom;
            return -1;
        },
        toggleInfobox:function(){
            if(cPicCacheIndex<0)return false; //no toggle
            var p=imgDiv.children[cPicCacheIndex],s=mediaShadow[cPicCacheIndex],r,c;
            console.assert(s.photostovisZoom!==2);
            console.assert(cPicAlbumIndex>=0 && !(picsInAlbum[cPicAlbumIndex].fl&PH.server.albumFlags.FlagIsVideo));
            var btm,rgt;
            var mapOptions,photoPos;

            //if here, we are inside the box
            if(showInfo){
                //hide the infobox
                showInfo=false;
                localStorage.showPicInfo=false;
                PH.sendPreferencesToPhonet();
                
                //prepare the transition
                infobox.style.transition="bottom 0.5s ease-out, right 0.5s ease-out";
                btm=5+34-infobox.clientHeight;
                rgt=5+34-infobox.clientWidth;
                //apply changes
                infobox.style.bottom=btm+"px";
                infobox.style.right=rgt+"px";
                s.photostovisInfoboxShown=false;
                
                if(s.photostovisZoom===0){
                    r=p.children[0];
                    r.style.transition="top 0.5s ease-out, left 0.5s ease-out";
                    r.style.top=s.photostovisTop+"px";
                    r.style.left=s.photostovisLeft+"px";
                } //else we do not change the position
                
                setTimeout(function(){
                    infobox.children[0].style.display=null;
                    infobox.style.width="34px";
                    infobox.style.height="34px";
                    infobox.style.bottom="5px";
                    infobox.style.right="5px";
                    infobox.style.transition=null;
                    p.children[0].style.transition=null;
                },500);
            } else {
                //show the infobox
                showInfo=true;
                localStorage.showPicInfo=true;
                PH.sendPreferencesToPhonet();
                //make sure we have the right info
                infobox.children[1].innerHTML=s.photostovisImgText;
                //do we show a map?
                c=picsInAlbum[cPicAlbumIndex];
                if(typeof(c.lat)!=='undefined'){
                    console.assert(typeof(c.lng)!=='undefined');
                    console.log("We have GPS pos: lat="+(c.lat/1000000)+", lng="+c.lng/1000000);
                    if(!map){
                        mapOptions={
                            center: {lat:c.lat/1000000, lng:c.lng/1000000},
                            zoom: 15
                        };
                        map=new google.maps.Map(infobox.children[2],mapOptions);
                        photoMarker=new google.maps.Marker({map: map});
                    }
                    //display the photomap
                    infobox.children[2].style.display=null;
                    google.maps.event.trigger(map,'resize');
                    //center the map
                    photoPos=new google.maps.LatLng(c.lat/1000000,c.lng/1000000);
                    map.setCenter(photoPos);
                    photoMarker.setPosition(photoPos);
                } else infobox.children[2].style.display='none';

                //move the infobox outside of our screen
                infobox.style.transition=null;
                infobox.style.right="-400px";
                //"show" the infobox
                infobox.children[0].style.display="none";
                infobox.style.width=null;
                infobox.style.height=null;
                //compute the starting right and bottom values
                btm=5+34-infobox.clientHeight;
                rgt=5+34-infobox.clientWidth;
                infobox.style.right=rgt+"px";
                infobox.style.bottom=btm+"px";
                
                setTimeout(function(){
                    //prepare the transition
                    infobox.style.transition="bottom 0.5s ease-out, right 0.5s ease-out";
                    //apply changes
                    infobox.style.bottom="5px";
                    infobox.style.right="5px";
                    s.photostovisInfoboxShown=true;
                    
                    if(s.photostovisZoom===0){
                        r=p.children[0];
                        r.style.transition="top 0.5s ease-out, left 0.5s ease-out";
                        r.style.top=s.photostovisTop0+"px";
                        r.style.left=s.photostovisLeft0+"px";
                    }
                   
                    setTimeout(function(){
                        infobox.style.transition=null;
                        p.children[0].style.transition=null;
                    },550);
                },0);

            }
            return true;
        },//togleInfobox
        toggleZoom:function(){
            if(cPicCacheIndex<0)return false; //no toggle
            var p=imgDiv.children[cPicCacheIndex],s=mediaShadow[cPicCacheIndex],r,c;
            var cssText;
            console.assert(cPicAlbumIndex>=0 && !(picsInAlbum[cPicAlbumIndex].fl&PH.server.albumFlags.FlagIsVideo));

            if(typeof(s.photostovisWidth)!=='number'){
                console.assert(typeof(s.photostovisHeight)!=='number');
                return false; //no toggle, there is no image
            } else {
                console.assert(typeof(s.photostovisHeight)==='number');
                console.assert(typeof(s.photostovisZ1Width)==='number');
                console.assert(typeof(s.photostovisZ1Height)==='number');
                console.assert(typeof(s.photostovisZ2Width)==='number');
                console.assert(typeof(s.photostovisZ2Height)==='number');
            }
            if(s.photostovisWidth<=0){
                console.assert(s.photostovisHeight<=0);
                return false; //no toggle, there is no image
            } else {
                console.assert(s.photostovisHeight>0);
                console.assert(s.photostovisZ1Width>0);
                console.assert(s.photostovisZ1Height>0);
                console.assert(s.photostovisZ2Width>0);
                console.assert(s.photostovisZ2Height>0);
            }

            if(s.photostovisRot.length)
                cssText=PH.platform.transformPrefix+'transform:'+s.photostovisRot+'; ';
            else cssText='';

            switch(s.photostovisZoom){
            case 0:
                p.children[0].style.cssText=cssText+'width:'+s.photostovisZ1Width+'px; height:'+s.photostovisZ1Height+
                        'px; top:'+s.photostovisZ1Top+'px; left:'+s.photostovisZ1Left+'px;';
                p.scrollTop=s.photostovisZ1ScrollTop;
                p.scrollLeft=s.photostovisZ1ScrollLeft;
                s.photostovisZoom=1;

                //we are showing zoom-in, right?
                console.assert(s.photostovisZ1Width>=s.photostovisWidth);
                //Should we change to zoom out?
                if(s.photostovisZ2Width<s.photostovisZ1Width){
                    //change to zoom-out
                    zoomInElm.style.display='none';
                    zoomOutElm.style.display='block';
                }

                break;
            case 1:
                p.children[0].style.cssText=cssText+'width:'+s.photostovisZ2Width+'px; height:'+s.photostovisZ2Height+
                        'px; top:'+s.photostovisZ2Top+'px; left:'+s.photostovisZ2Left+'px;';
                p.scrollTop=s.photostovisZ2ScrollTop;
                p.scrollLeft=s.photostovisZ2ScrollLeft;
                s.photostovisZoom=2;

                //change what zoom is showing?
                if(s.photostovisZ2Width<s.photostovisZ1Width && s.photostovisZ2Width<s.photostovisWidth){
                    zoomOutElm.style.display='none';
                    zoomInElm.style.display='block';
                }
                if(s.photostovisZ2Width>s.photostovisZ1Width && s.photostovisZ2Width>s.photostovisWidth){
                    zoomInElm.style.display='none';
                    zoomOutElm.style.display='block';
                }
                //hide the infobox
                infobox.style.display='none';
                break;
            case 2:
                if(showInfo)
                    cssText+='top:'+s.photostovisTop0+'px;left:'+s.photostovisLeft0+'px;';
                else
                    cssText+='top:'+s.photostovisTop+'px;left:'+s.photostovisLeft+'px;';
                p.children[0].style.cssText=cssText+'width:'+s.photostovisWidth+'px; height:'+s.photostovisHeight+'px;';
                s.photostovisZoom=0;

                //change what zoom is showing?
                console.assert(s.photostovisZ1Width>=s.photostovisWidth);
                if(s.photostovisZ2Width>s.photostovisWidth){
                    zoomOutElm.style.display='none';
                    zoomInElm.style.display='block';
                }

                //show the infobox
                infobox.style.display='';
                break;
            }//switch

            return true;
        }//togleZoom
    };//returned object    
})();
